import express from 'express';
import bodyParser from 'body-parser';

import ModelModel from '../models/model';

const router = express.Router();

router.get('/model/:name', (req, res, next) => {
  if (!req.auth(res, ['dev', 'admin'], 'all')) return;

  ModelModel.findOne({name: req.params.name}).lean().exec((err, data) => {
    if (err) return next(err);
    if (data) {
      res.set('Content-Type', 'application/octet-stream');
      res.send(data.data.buffer);
    }
    else {
      res.status(404).json({status: 'Not found'});
    }
  });
});

router.post('/model/:name', bodyParser.raw({limit: '500kb'}), (req, res, next) => {
  if (!req.auth(res, ['dev', 'admin'], 'all')) return;

  ModelModel.replaceOne({name: req.params.name}, {name: req.params.name, data: req.body}).setOptions({upsert: true})
    .lean().exec(err => {
    if (err) return next(err);
    res.json({status: 'OK'});
  });
});

router.delete('/model/:name', (req, res, next) => {
  if (!req.auth(res, ['dev', 'admin'], 'basic')) return;

  ModelModel.findOneAndDelete({name: req.params.name}).lean().exec((err, data) => {
    if (err) return next(err);
    if (data) {
      res.json({status: 'OK'});
    }
    else {
      res.status(404).json({status: 'Not found'});
    }
  });
});

module.exports = router;